// 此文件不要写具体逻辑，只调用函数
import {
    twitterShortUrl,
    twitterPinLoginToken,
    twitterPinLoginCode,
    onInstalledMid,
    onInstalledUserSet,
    onInstalledCreateTab,
    checkPined,
    popupRePublish,
    setBadgeInfo,
    hideBadge
} from "@/logic/background/twitter";

// 消息通讯
chrome.runtime.onConnect.addListener(function (port) {
    port.onMessage.addListener(function (res) {
        switch (res.state) {
            case "CONTENT_SEND_CODE":
                twitterPinLoginCode(port, res.code);
                break;
            case "CONTENT_TWITTER_LOGIN":
                twitterPinLoginToken();
                break;
            case "CONTENT_TWITTER_SHORT_LINK":
                res.arr_url.forEach(item => {
                    if(item){
                        twitterShortUrl(port,item)
                    }
                });
                break
        }
    });
});

chrome.runtime.onInstalled.addListener(onInstalledMethod);

chrome.runtime.onMessage.addListener(onMessageMethod);

function onInstalledMethod() {
    onInstalledCreateTab()
    onInstalledMid()
    onInstalledUserSet()
}

function onMessageMethod(req, sender, sendResponse) {
    sendResponse('');
    if (req) {
        switch (req.actionType) {
            case "POPUP_LOGIN":
                twitterPinLoginToken();
                break;
            case "POPUP_PUBLISH_TWITTER_RED_PACK":
                popupRePublish(req);
                break;
            case 'CONTENT_GET_PINED':
                checkPined();
                break;
            case 'CONTENT_SET_BADGE':
                setBadgeInfo(req);
                break;
            case 'CONTENT_HIDE_BADGE':
                hideBadge();
                break;
        }
    }
}
